﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Xml;
using System.Xml.Linq;
using System.Xml.Schema;

namespace lambda
{
    class Program
    {
        static void Main(string[] args)
        {
            string xsdMarkup =
          @"<xs:schema attributeFormDefault='unqualified'
                       elementFormDefault='qualified'
                       xmlns:xs='http://www.w3.org/2001/XMLSchema'>
              <xs:element name='Client'>
                <xs:complexType>
                  <xs:attribute name='Id'
                                type='xs:integer' use='required' />
                </xs:complexType>
              </xs:element>
            </xs:schema>";
            XmlSchemaSet schema = new XmlSchemaSet();
            schema.Add("", XmlReader.Create(new StringReader(xsdMarkup)));
            ValidateStringDoc(schema, "<Client Idx='0001'/>");
            ValidateStringDoc(schema, "<Client Id='A001'/>");
            ValidateStringDoc(schema, "<Client Id='0001'/>");

            Console.ReadLine();
        }

        private static void ValidateStringDoc(XmlSchemaSet schema, string doc)
        {
            XDocument document = XDocument.Parse(doc);
            ValidateXML(schema, document);
        }

        private static void ValidateXML(XmlSchemaSet schema, XDocument doc)
        {
            Console.WriteLine("\nValidation XML");
            string errors = string.Empty;
            doc.Validate(schema, (obj, e) => errors += e.Message + Environment.NewLine);
            if (string.IsNullOrEmpty(errors))
                Console.WriteLine("Validation Ok");
            else
                Console.WriteLine("Il y a des erreurs :\n" + errors);
        }
    }
}
